import { ElementRef, EventEmitter } from '@angular/core';
import { WidgetConfig } from '../../models/WidgetConfig.model';
import { Rectangle } from '../../models/Rectangle.model';
import { RESIZE_DIRECTIONS } from '../../Utils';
import { NgxWidgetGridComponent } from '../grid/grid.component';
import * as i0 from "@angular/core";
export declare class NgxWidgetComponent {
    private elRef;
    gridCmp?: NgxWidgetGridComponent;
    swapOnMove: boolean;
    positionChange: EventEmitter<Rectangle>;
    movable: boolean;
    allDirections: typeof RESIZE_DIRECTIONS;
    isTopResizable: boolean;
    isRightResizable: boolean;
    isBottomResizable: boolean;
    isLeftResizable: boolean;
    isTopRightResizable: boolean;
    isTopLeftResizable: boolean;
    isBottomRightResizable: boolean;
    isBottomLeftResizable: boolean;
    widgetConfig: WidgetConfig;
    _position: Rectangle;
    _resizable: boolean;
    _resizeDirections: RESIZE_DIRECTIONS[];
    constructor(elRef: ElementRef, gridCmp?: NgxWidgetGridComponent);
    get position(): Rectangle;
    set position(position: Rectangle);
    get resizable(): boolean;
    set resizable(resizable: boolean);
    get resizeDirections(): RESIZE_DIRECTIONS[];
    set resizeDirections(dirs: RESIZE_DIRECTIONS[]);
    setResizeDirections(): void;
    getConfig(): WidgetConfig;
    getEl(): ElementRef;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxWidgetComponent, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxWidgetComponent, "ngx-widget", never, { "swapOnMove": "swapOnMove"; "movable": "movable"; "position": "position"; "resizable": "resizable"; "resizeDirections": "resizeDirections"; }, { "positionChange": "positionChange"; }, never, ["*"], false, never>;
}
